/* Copyright (c) 2013 tonomu
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#include<stdio.h>
#include "mbt.h"

static const char * const ERR_COMMENT[] = {
"no information",
"internal error",

"invalid input TPQN",
"failed to close input file",
"failed to calculate gcd",
"invalid format",
"failed to close output file",
"missing flag",
"illegal entry",
"invalid flag",
"missing filename",
"illegal filename entry",
"filename length overflow",
"empty data",
"illegal TPQN entry ",
"unsupported TPQN",
"illegal TPQN",
"invalid TPQN",
"tick overflow",
"invalid input file",
"failed to open input file",
"failed to open output file",
"RFU1 (mbt.c)",
"RFU2 (mbt.c)",
"RFU3 (mbt.c)",

"malloc failure",
"unsupported file type",
"unsupported header",
"unsupported format",
"unsupported track type",
"illegal track size",
"malloc failure",
"illegal track data",
"illegal track size",
"realloc failure",
"getc failure",
"time overflow",
"illegal length format",
"illegal running status",
"malloc failure",
"unsupported event type",
"RFU1 (get_data.c)",
"RFU2 (get_data.c)",
"RFU3 (get_data.c)",

"unsupported TPQN",
"illegal TPQN",
"failed to write header",
"malloc failure",
"failed to write comment",
"bar count overflow",
"realloc failure",
"measure tick overflow",
"failed to write mbt",
"unsupported event type",
"failed to write event",
"failed to write event",
"illegal bend data",
"failed to write tone",
"illegal length format",
"failed to write comment",
"failed to write text",
"unsupported tempo value",
"failed to write time signature",
"unsupported time signature",
"failed to write key signature",
"illegal beat value",
"RFU1 (write_data.c)",
"RFU2 (write_data.c)",
"RFU3 (write_data.c)",

"illegal line",
"unsupported TPQN",
"illegal TPQN",
"malloc failure",
"malloc failure",
"malloc failure",
"malloc failure",
"row count overflow",
"ungetc failure",
"illegal colon entry",
"unexpected EOF",
"unexpected return",
"line count overflow",
"realloc failure",
"event count overflow",
"realloc failure",
"invalid character",
"invalid data",
"invalid time character",
"invalid mbt character",
"illegal beat value",
"illegal mbt structure",
"bar count overflow",
"realloc failure",
"measure tick overflow",
"illegal tick",
"event data missing",
"illegal data length",
"invalid duration",
"invalid event data",
"unsupported event type",
"illegal data length",
"data length overflow",
"value overflow",
"unsupported prefix",
"hex value overflow",
"invalid hex data",
"event buffer overflow",
"illegal channel entry",
"invalid channel entry",
"unsupported channel entry",
"invalid character",
"unsupported tone number",
"invalid tone number",
"unsupported tone number",
"unsupported tone name",
"invalid pitch value",
"invalid tempo value",
"illegal tempo value",
"unsupported tempo value",
"unexpected string close",
"text length overflow",
"invalid character",
"illegal beat value",
"beat value overflow",
"value overflow",
"illegal meter change",
"unsupported beat value",
"malloc failure",
"tick overflow",
"track count overflow",
"realloc failure",
"malloc failure",
"RFU1 (read_data.c)",
"RFU2 (read_data.c)",
"RFU3 (read_data.c)",

"track count overflow",
"unsupported TPQN",
"failed to output MThd",
"failed to output header",
"unsupported SMF format",
"failed to output format",
"failed to output track count",
"failed to output TPQN",
"failed to fgetpos",
"failed to fgetpos",
"failed to fsetpos",
"failed to fsetpos",
"failed to output MTrk",
"failed to output track size",
"track size overflow",
"failed to output track size",
"illegal delta tick",
"failed to output tick",
"failed to output event",
"unsupported event type",
"illegal data length",
"illegal data length",
"RFU1 (put_data.c)",
"RFU2 (put_data.c)",
"RFU3 (put_data.c)"
};

int Print_Error(int status)
{

  if (status >= 0) { return status; }
  if (status < -159) { status = E_A_NO_INFO; }

  (void) printf("error: %s (code: %d)\n", ERR_COMMENT[status * (-1)], status);

  return status;
}
